## com.puppycrawl.tools.checkstyle.checks.design
Class VisibilityModifierCheck

    java.lang.Object
      com.puppycrawl.tools.checkstyle.api.AutomaticBean
          com.puppycrawl.tools.checkstyle.api.AbstractViolationReporter
              com.puppycrawl.tools.checkstyle.api.Check
                  com.puppycrawl.tools.checkstyle.checks.design.VisibilityModifierCheck

All Implemented Interfaces:
  Configurable, Contextualizable

    public class VisibilityModifierCheck

extends Check

Checks visibility of class members. Only static final members may be public, other class members must be private unless allowProtected/Package is set.

Public members are not flagged if the name matches the public member regular expression (contains "^serialVersionUID$" by default).

Rationale: Enforce encapsulation.

Author:
  lkuehne

Constructor Summary
`VisibilityModifierCheck()` Create an instance.

Method Summary
`int[]` `getDefaultTokens()` Returns the default token a check is interested in.
`boolean` `isPackageAllowed()`
`boolean` `isProtectedAllowed()`
`void` `setPackageAllowed(boolean aPackageAllowed)` Set whether package visible members are allowed.
`void` `setProtectedAllowed(boolean aProtectedAllowed)` Set whether protected members are allowed.
`void` `setPublicMemberPattern(String aPattern)` Set the pattern for public members to ignore.
`void` `visitToken(DetailAST aAST)` Called to process a token.

Methods inherited from class com.puppycrawl.tools.checkstyle.api.Check
`beginTree, destroy, finishTree, getAcceptableTokens, getClassLoader, getFileContents, getLines, getRequiredTokens, getTabWidth, getTokenNames, init, leaveToken, log, log, setClassLoader, setFileContents, setMessages, setTabWidth, setTokens`

Methods inherited from class com.puppycrawl.tools.checkstyle.api.AbstractViolationReporter
`getCustomMessages, getId, getMessageBundle, getSeverity, getSeverityLevel, log, setId, setSeverity`

Methods inherited from class com.puppycrawl.tools.checkstyle.api.AutomaticBean
`configure, contextualize, finishLocalSetup, getConfiguration, setupChild`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VisibilityModifierCheck

    public VisibilityModifierCheck()

  Create an instance.

Method Detail

### isProtectedAllowed

    public boolean isProtectedAllowed()

  Returns:
    whether protected members are allowed

### setProtectedAllowed

    public void setProtectedAllowed(boolean aProtectedAllowed)

  Set whether protected members are allowed.

  Parameters:
    `aProtectedAllowed` - whether protected members are allowed

### isPackageAllowed

    public boolean isPackageAllowed()

  Returns:
    whether package visible members are allowed

### setPackageAllowed

    public void setPackageAllowed(boolean aPackageAllowed)

  Set whether package visible members are allowed.

  Parameters:
    `aPackageAllowed` - whether package visible members are allowed

### setPublicMemberPattern

    public void setPublicMemberPattern(String aPattern)

  Set the pattern for public members to ignore.

  Parameters:
    `aPattern` - pattern for public members to ignore.

### getDefaultTokens

    public int[] getDefaultTokens()

  Description copied from class: `Check`
  Returns the default token a check is interested in. Only used if the configuration for a check does not define the tokens.

  Specified by:
    `getDefaultTokens` in class `Check`
  Returns:
    the default tokens
  See Also:
    `TokenTypes`

### visitToken

    public void visitToken(DetailAST aAST)

  Description copied from class: `Check`
  Called to process a token.

  Overrides:
    `visitToken` in class `Check`
  Parameters:
    `aAST` - the token to process

Copyright © 2001-2011. All Rights Reserved.